<!DOCTYPE html>
<html lang="es">
    <head>
        <meta charset="UTF-8">
        <meta name="viewport" content="width-device-width, initial-scale=1.0">
        <title>Trainee Meeting #7 - Acamica BACKEND</title>
    </head>
    <body>
        <button id="btnListaTodos">Todos los perros</button>
        <br>
        <button id="btnListaEnAdopcion">Perros en adopcion</button>
        <br>
        <button id="btnListaEnProcesoAdopcion">Perros en proceso de adopcion</button>
        <br>
        <button id="btnListaAdoptados">Perros adoptados</button>
        <script>
            let perros = [];
            const estados = ['En adopcion', 'Proceso de adopción', 'Adoptado'];
            const tamanyos = ['Pequeño', 'Mediano', 'Grande'];

            class Perro{
                constructor(nombre, raza, edad, tamanyo, estado){
                    this.nombre = nombre;
                    this.raza = raza;
                    this.edad = edad;
                    this.tamanyo = tamanyo;
                    this.estado = estado;
                }

                set setEstado(estado){ this.estado = estado };
                get getEstado(){ return this.estado };                
            }

            const solicitarDatosPerro = () => {
                do {
                    let perro = {}
                    perro.nombre = prompt("Ingrese el nombre del perro: ");

                    perro.raza = prompt("Ingrese raza: ");

                    perro.edad = prompt("Ingrese edad del can (valor entre 1 y 20): ");

                    perro.tamanyo =  prompt("Tamaño del can (ingrese opcion correspondiente(1,2 o 3)):\n1) CHICO\n2) MEDIANO\n3) GRANDE");
                    perro.tamanyo = validarOpciones(perro.tamanyo, "Tamaño del can (ingrese opcion correspondiente(1,2 o 3)):\n1) CHICO\n2) MEDIANO\n3) GRANDE");
                    perro.tamanyo--;
                    perro.tamanyo = tamanyos[perro.tamanyo];

                    perro.estado =  prompt("Estado (ingrese opcion correspondiente(1,2 o 3)):\n1) EN ADOPCION\n2) EN PROCESO DE ADOPCION\n3) ADOPTADO");
                    perro.estado = validarOpciones(perro.estado, "Estado (ingrese opcion correspondiente(1,2 o 3)):\n1) EN ADOPCION\n2) EN PROCESO DE ADOPCION\n3) ADOPTADO");
                    perro.estado--;
                    perro.estado = estados[perro.estado];

                    let perroCargado = new Perro(perro.nombre, perro.raza, perro.edad, perro.tamanyo, perro.estado);
                    perros.push(perroCargado);
                    alert('Perro: ' + perroCargado.nombre + ' cargado correctamente, con el estado ' + perro.estado + '.');
                } while (window.confirm("¿Desea agregar un nuevo perro?"));
            }

            solicitarDatosPerro();

            // Funcion p/ generar los reportes //
            const generarReportes = (estado) => {
                if (estado === 'todos') {
                    console.log('Lista de todos los perros: ');
                    for (let i = 0; i<perros.length; i++) {
                        console.log(perros[i]);
                    }
                } else { 
                    
                    console.log('Lista de perros con estado: ' + estado);
                    for (let i = 0; i<perros.length; i++) {
                        if (perros[i].estado === estado) console.log(perros[i]);
                    }
                }
            }

            // Esta funcion valida las opciones numericas ingresadas p/ tamaño y estado del perro //
            const validarOpciones = (valorIngresado, msj) => {
                while (!valorIngresado || valorIngresado < 1 || valorIngresado > 3) {
                    valorIngresado =  prompt(`Por favor, ingrese una opcion valida\n ${msj}`);
                }
                return valorIngresado;
            }

            // Generacion de reportes (en console.log) //
            document.getElementById("btnListaTodos").addEventListener("click", function() {
                generarReportes('todos');
            });

            document.getElementById("btnListaEnAdopcion").addEventListener("click", function() {
                generarReportes('En adopcion');
            });
            
            document.getElementById("btnListaEnProcesoAdopcion").addEventListener("click", function() {
                generarReportes('Proceso de adopción');
            });

            document.getElementById("btnListaAdoptados").addEventListener("click", function() {
                generarReportes('Adoptado');
            });
        </script>
    </body>
</html>